#include<bits/stdc++.h>
using namespace std;
const long long MAXN=1000005;
long long N, last[MAXN], sum[MAXN], ans, a, b;
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin>>N;
    last[0]=-1;
    sum[0]=0;
    for(long long i=1; i<=N; i++){
        cin>>a>>b;
        if(b!=0){
            last[i]=a;
            sum[i]=sum[a]+b;
        }else{
            last[i]=last[a];
            sum[i]=sum[last[i]];
        }
        ans+=sum[i];
    }
    cout<<ans<<endl;
    return 0;
}

